import * as _codemirror_state from '@codemirror/state';
import { Extension, EditorStateConfig, EditorState } from '@codemirror/state';
import { ViewUpdate, EditorView } from '@codemirror/view';

declare const _default: _codemirror_state.Extension[];

interface EventCallbacks {
    onChange?(doc: string, viewUpdate: ViewUpdate): void;
    onChangeInterval?: number;
    onUpdate?(viewUpdate: ViewUpdate): void;
    onFocus?(viewUpdate: ViewUpdate): void;
    onBlur?(viewUpdate: ViewUpdate): void;
    onPaste?(event: ClipboardEvent, view: EditorView): void;
}
declare function eventsToExtensions({ onChange, onFocus, onBlur, onPaste, onChangeInterval }?: EventCallbacks): Extension[];

declare function createState(state?: EditorStateConfig, events?: EventCallbacks): EditorState;
declare function createEditor(element: HTMLElement, state?: EditorStateConfig, events?: EventCallbacks): EditorView;

export { type EventCallbacks, createEditor, createState, eventsToExtensions, _default as extensions };
